Index: /palm/trunk/UTIL/inifor/src/inifor_io.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_io.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_io.f90	(revision 3866)
@@ -26,4 +26,9 @@
 ! -----------------
 ! $Id$
+! Use PALM's working precision
+! Improved coding style
+!
+! 
+! 3801 2019-03-15 17:14:25Z eckhard
 ! Added routine get_cosmo_grid() to read in COSMO rotated pole from COSMO domain
 ! Moved get_soil_layer_thickness() here from inifor_grid
@@ -118,8 +123,8 @@
     USE inifor_control
     USE inifor_defs,                                                           &
-        ONLY:  DATE, SNAME, PATH, PI, dp, hp, TO_RADIANS, TO_DEGREES, VERSION, &
+        ONLY:  DATE, SNAME, PATH, PI, TO_RADIANS, TO_DEGREES, VERSION,         &
                NC_DEPTH_NAME, NC_HHL_NAME, NC_RLAT_NAME, NC_RLON_NAME,         &
                NC_ROTATED_POLE_NAME, NC_POLE_LATITUDE_NAME,                    &
-               NC_POLE_LONGITUDE_NAME, RHO_L
+               NC_POLE_LONGITUDE_NAME, RHO_L, wp, iwp
     USE inifor_types
     USE inifor_util,                                                           &
@@ -133,5 +138,5 @@
 ! ------------
 !> get_netcdf_variable() reads the netCDF data and metadate for the netCDF
-!> variable 'in_var % name' from the file 'in_file'. The netCDF data array is
+!> variable 'in_var%name' from the file 'in_file'. The netCDF data array is
 !> stored in the 'buffer' array and metadata added to the respective members of
 !> the given 'in_var'.
@@ -152,40 +157,40 @@
 !> get_netcdf_variable interface.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_netcdf_variable_int(in_file, in_var, buffer)
-
-       CHARACTER(LEN=PATH), INTENT(IN)         ::  in_file
-       TYPE(nc_var), INTENT(INOUT)             ::  in_var
-       INTEGER(hp), ALLOCATABLE, INTENT(INOUT) ::  buffer(:,:,:)
-
-       INTEGER               ::  ncid
-       INTEGER, DIMENSION(3) ::  start, count
-
-       IF ( nf90_open( TRIM(in_file), NF90_NOWRITE, ncid ) .EQ. NF90_NOERR .AND. &
-            nf90_inq_varid( ncid, in_var % name, in_var % varid ) .EQ. NF90_NOERR )  THEN
-
-          CALL get_input_dimensions(in_var, ncid)
-
-          CALL get_netcdf_start_and_count(in_var, start, count)
- CALL run_control('time', 'read')
-
-          ALLOCATE( buffer( count(1), count(2), count(3) ) )
- CALL run_control('time', 'alloc')
-
-          CALL check(nf90_get_var( ncid, in_var % varid, buffer,                  &
-                                   start = start,                                 &
-                                   count = count ))
-
-       ELSE
-
-          message = "Failed to read '" // TRIM(in_var % name) // &
-             "' from file '" // TRIM(in_file) // "'."
-          CALL inifor_abort('get_netcdf_variable', message)
-
-       ENDIF
-
-       CALL check(nf90_close(ncid))
- CALL run_control('time', 'read')
-
-    END SUBROUTINE get_netcdf_variable_int
+ SUBROUTINE get_netcdf_variable_int(in_file, in_var, buffer)
+
+    CHARACTER(LEN=PATH), INTENT(IN)          ::  in_file
+    TYPE(nc_var), INTENT(INOUT)              ::  in_var
+    INTEGER(iwp), ALLOCATABLE, INTENT(INOUT) ::  buffer(:,:,:)
+
+    INTEGER               ::  ncid
+    INTEGER, DIMENSION(3) ::  start, count
+
+    IF ( nf90_open( TRIM(in_file), NF90_NOWRITE, ncid ) .EQ. NF90_NOERR .AND. &
+         nf90_inq_varid( ncid, in_var%name, in_var%varid ) .EQ. NF90_NOERR )  THEN
+
+       CALL get_input_dimensions(in_var, ncid)
+
+       CALL get_netcdf_start_and_count(in_var, start, count)
+       CALL log_runtime('time', 'read')
+
+       ALLOCATE( buffer( count(1), count(2), count(3) ) )
+       CALL log_runtime('time', 'alloc')
+
+       CALL check(nf90_get_var( ncid, in_var%varid, buffer,                  &
+                                start = start,                                 &
+                                count = count ))
+
+    ELSE
+
+       message = "Failed to read '" // TRIM(in_var%name) // &
+          "' from file '" // TRIM(in_file) // "'."
+       CALL inifor_abort('get_netcdf_variable', message)
+
+    ENDIF
+
+    CALL check(nf90_close(ncid))
+    CALL log_runtime('time', 'read')
+
+ END SUBROUTINE get_netcdf_variable_int
 
 
@@ -196,40 +201,40 @@
 !> get_netcdf_variable interface.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_netcdf_variable_real(in_file, in_var, buffer)
-
-       CHARACTER(LEN=PATH), INTENT(IN)      ::  in_file
-       TYPE(nc_var), INTENT(INOUT)          ::  in_var
-       REAL(dp), ALLOCATABLE, INTENT(INOUT) ::  buffer(:,:,:)
-
-       INTEGER               ::  ncid
-       INTEGER, DIMENSION(3) ::  start, count
-
-       IF ( nf90_open( TRIM(in_file), NF90_NOWRITE, ncid ) .EQ. NF90_NOERR .AND. &
-            nf90_inq_varid( ncid, in_var % name, in_var % varid ) .EQ. NF90_NOERR )  THEN
-
-          CALL get_input_dimensions(in_var, ncid)
-
-          CALL get_netcdf_start_and_count(in_var, start, count)
- CALL run_control('time', 'read')
-
-          ALLOCATE( buffer( count(1), count(2), count(3) ) )
- CALL run_control('time', 'alloc')
-
-          CALL check(nf90_get_var( ncid, in_var % varid, buffer,                  &
-                                   start = start,                                 &
-                                   count = count ))
-
-       ELSE
-
-          message = "Failed to read '" // TRIM(in_var % name) // &
-             "' from file '" // TRIM(in_file) // "'."
-          CALL inifor_abort('get_netcdf_variable', message)
-
-       ENDIF
-
-       CALL check(nf90_close(ncid))
- CALL run_control('time', 'read')
-
-    END SUBROUTINE get_netcdf_variable_real
+ SUBROUTINE get_netcdf_variable_real(in_file, in_var, buffer)
+
+    CHARACTER(LEN=PATH), INTENT(IN)      ::  in_file
+    TYPE(nc_var), INTENT(INOUT)          ::  in_var
+    REAL(wp), ALLOCATABLE, INTENT(INOUT) ::  buffer(:,:,:)
+
+    INTEGER               ::  ncid
+    INTEGER, DIMENSION(3) ::  start, count
+
+    IF ( nf90_open( TRIM(in_file), NF90_NOWRITE, ncid ) .EQ. NF90_NOERR .AND. &
+         nf90_inq_varid( ncid, in_var%name, in_var%varid ) .EQ. NF90_NOERR )  THEN
+
+       CALL get_input_dimensions(in_var, ncid)
+
+       CALL get_netcdf_start_and_count(in_var, start, count)
+       CALL log_runtime('time', 'read')
+
+       ALLOCATE( buffer( count(1), count(2), count(3) ) )
+       CALL log_runtime('time', 'alloc')
+
+       CALL check(nf90_get_var( ncid, in_var%varid, buffer,                  &
+                                start = start,                                 &
+                                count = count ))
+
+    ELSE
+
+       message = "Failed to read '" // TRIM(in_var%name) // &
+          "' from file '" // TRIM(in_file) // "'."
+       CALL inifor_abort('get_netcdf_variable', message)
+
+    ENDIF
+
+    CALL check(nf90_close(ncid))
+    CALL log_runtime('time', 'read')
+
+ END SUBROUTINE get_netcdf_variable_real
 
 
@@ -240,31 +245,31 @@
 !> netCDF file 'filename'.
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_netcdf_dim_vector(filename, coordname, coords)
-
-       CHARACTER(LEN=*), INTENT(IN)         ::  filename
-       CHARACTER(LEN=*), INTENT(IN)         ::  coordname
-       REAL(dp), ALLOCATABLE, INTENT(INOUT) ::  coords(:)
-
-       INTEGER ::  ncid, varid, dimlen
-       INTEGER ::  dimids(NF90_MAX_VAR_DIMS)
-
-       IF ( nf90_open( TRIM(filename), NF90_NOWRITE, ncid ) .EQ. NF90_NOERR .AND. &
-            nf90_inq_varid( ncid, coordname, varid ) .EQ. NF90_NOERR )  THEN
-
-          CALL check(nf90_inquire_variable( ncid, varid, dimids = dimids ))
-          CALL check(nf90_inquire_dimension( ncid, dimids(1), len = dimlen ))
-
-          ALLOCATE(coords(dimlen))
-          CALL check(nf90_get_var( ncid, varid, coords))
-
-       ELSE
-
-          message = "Failed to read '" // TRIM(coordname) // &
-             "' from file '" // TRIM(filename) // "'."
-          CALL inifor_abort('get_netcdf_dim_vector', message)
-
-       ENDIF
-
-    END SUBROUTINE get_netcdf_dim_vector
+ SUBROUTINE get_netcdf_dim_vector(filename, coordname, coords)
+
+    CHARACTER(LEN=*), INTENT(IN)         ::  filename
+    CHARACTER(LEN=*), INTENT(IN)         ::  coordname
+    REAL(wp), ALLOCATABLE, INTENT(INOUT) ::  coords(:)
+
+    INTEGER ::  ncid, varid, dimlen
+    INTEGER ::  dimids(NF90_MAX_VAR_DIMS)
+
+    IF ( nf90_open( TRIM(filename), NF90_NOWRITE, ncid ) .EQ. NF90_NOERR .AND. &
+         nf90_inq_varid( ncid, coordname, varid ) .EQ. NF90_NOERR )  THEN
+
+       CALL check(nf90_inquire_variable( ncid, varid, dimids = dimids ))
+       CALL check(nf90_inquire_dimension( ncid, dimids(1), len = dimlen ))
+
+       ALLOCATE(coords(dimlen))
+       CALL check(nf90_get_var( ncid, varid, coords))
+
+    ELSE
+
+       message = "Failed to read '" // TRIM(coordname) // &
+          "' from file '" // TRIM(filename) // "'."
+       CALL inifor_abort('get_netcdf_dim_vector', message)
+
+    ENDIF
+
+ END SUBROUTINE get_netcdf_dim_vector
 
 
@@ -273,30 +278,30 @@
 ! ------------
 !> get_input_dimensions() reads dimensions metadata of the netCDF variable given
-!> by 'in_var % name' into 'in_var' data structure.
-!------------------------------------------------------------------------------!
-    SUBROUTINE get_input_dimensions(in_var, ncid)
-
-       TYPE(nc_var), INTENT(INOUT) ::  in_var
-       INTEGER, INTENT(IN)         ::  ncid
-
-       INTEGER ::  i
-
-       CALL check(nf90_get_att( ncid, in_var % varid, "long_name",             &
-                                in_var % long_name))
-
-       CALL check(nf90_get_att( ncid, in_var % varid, "units",                 &
-                                in_var % units ))
-
-       CALL check(nf90_inquire_variable( ncid, in_var % varid,                 &
-                                         ndims  = in_var % ndim,               &
-                                         dimids = in_var % dimids ))
-
-       DO i = 1, in_var % ndim
-          CALL check(nf90_inquire_dimension( ncid, in_var % dimids(i),         &
-                                             name = in_var % dimname(i),       &
-                                             len  = in_var % dimlen(i) ))
-       ENDDO
-
-    END SUBROUTINE get_input_dimensions
+!> by 'in_var%name' into 'in_var' data structure.
+!------------------------------------------------------------------------------!
+ SUBROUTINE get_input_dimensions(in_var, ncid)
+
+    TYPE(nc_var), INTENT(INOUT) ::  in_var
+    INTEGER, INTENT(IN)         ::  ncid
+
+    INTEGER ::  i
+
+    CALL check(nf90_get_att( ncid, in_var%varid, "long_name",             &
+                             in_var%long_name))
+
+    CALL check(nf90_get_att( ncid, in_var%varid, "units",                 &
+                             in_var%units ))
+
+    CALL check(nf90_inquire_variable( ncid, in_var%varid,                 &
+                                      ndims  = in_var%ndim,               &
+                                      dimids = in_var%dimids ))
+
+    DO  i = 1, in_var%ndim
+       CALL check(nf90_inquire_dimension( ncid, in_var%dimids(i),         &
+                                          name = in_var%dimname(i),       &
+                                          len  = in_var%dimlen(i) ))
+    ENDDO
+
+ END SUBROUTINE get_input_dimensions
 
 
@@ -308,41 +313,41 @@
 !> and _real() for reading input variables..
 !------------------------------------------------------------------------------!
-    SUBROUTINE get_netcdf_start_and_count(in_var, start, count)
-
-       TYPE(nc_var), INTENT(INOUT)        ::  in_var
-       INTEGER, DIMENSION(3), INTENT(OUT) ::  start, count
-
-       INTEGER ::  ndim
-
-       IF ( in_var % ndim .LT. 2  .OR.  in_var % ndim .GT. 4 )  THEN
-
-          message = "Failed reading NetCDF variable " //                       &
-             TRIM(in_var % name) // " with " // TRIM(str(in_var % ndim)) //    &
-             " dimensions because only two- and and three-dimensional" //      &
-             " variables are supported."
-          CALL inifor_abort('get_netcdf_start_and_count', message)
-
-       ENDIF
-
-       start = (/ 1, 1, 1 /)
-       IF ( TRIM(in_var % name) .EQ. 'T_SO' )  THEN
-!
-!--       Skip depth = 0.0 for T_SO and reduce number of depths from 9 to 8
-          in_var % dimlen(3) = in_var % dimlen(3) - 1
-
-!
-!--       Start reading from second level, e.g. depth = 0.005 instead of 0.0
-          start(3) = 2
-       ENDIF
-
-       IF (in_var % ndim .EQ. 2)  THEN
-          in_var % dimlen(3) = 1
-       ENDIF
-
-       ndim = MIN(in_var % ndim, 3)
-       count = (/ 1, 1, 1 /)
-       count(1:ndim) = in_var % dimlen(1:ndim)
-
-    END SUBROUTINE get_netcdf_start_and_count
+ SUBROUTINE get_netcdf_start_and_count(in_var, start, count)
+
+    TYPE(nc_var), INTENT(INOUT)        ::  in_var
+    INTEGER, DIMENSION(3), INTENT(OUT) ::  start, count
+
+    INTEGER ::  ndim
+
+    IF ( in_var%ndim .LT. 2  .OR.  in_var%ndim .GT. 4 )  THEN
+
+       message = "Failed reading NetCDF variable " //                       &
+          TRIM(in_var%name) // " with " // TRIM(str(in_var%ndim)) //    &
+          " dimensions because only two- and and three-dimensional" //      &
+          " variables are supported."
+       CALL inifor_abort('get_netcdf_start_and_count', message)
+
+    ENDIF
+
+    start = (/ 1, 1, 1 /)
+    IF ( TRIM(in_var%name) .EQ. 'T_SO' )  THEN
+!
+!--    Skip depth = 0.0 for T_SO and reduce number of depths from 9 to 8
+       in_var%dimlen(3) = in_var%dimlen(3) - 1
+
+!
+!--    Start reading from second level, e.g. depth = 0.005 instead of 0.0
+       start(3) = 2
+    ENDIF
+
+    IF (in_var%ndim .EQ. 2)  THEN
+       in_var%dimlen(3) = 1
+    ENDIF
+
+    ndim = MIN(in_var%ndim, 3)
+    count = (/ 1, 1, 1 /)
+    count(1:ndim) = in_var%dimlen(1:ndim)
+
+ END SUBROUTINE get_netcdf_start_and_count
 
 
@@ -353,19 +358,19 @@
 !> output.
 !------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_define_variable(var, ncid)
-
-        TYPE(nc_var), INTENT(INOUT) ::  var
-        INTEGER, INTENT(IN)         ::  ncid
-
-        CALL check(nf90_def_var(ncid, var % name, NF90_FLOAT,       var % dimids(1:var % ndim), var % varid))
-        CALL check(nf90_put_att(ncid, var % varid, "long_name",     var % long_name))
-        CALL check(nf90_put_att(ncid, var % varid, "units",         var % units))
-        IF ( var % lod .GE. 0 )  THEN
-           CALL check(nf90_put_att(ncid, var % varid, "lod",           var % lod))
-        ENDIF 
-        CALL check(nf90_put_att(ncid, var % varid, "source",        var % source))
-        CALL check(nf90_put_att(ncid, var % varid, "_FillValue",    NF90_FILL_REAL))
-
-    END SUBROUTINE netcdf_define_variable
+ SUBROUTINE netcdf_define_variable(var, ncid)
+
+     TYPE(nc_var), INTENT(INOUT) ::  var
+     INTEGER, INTENT(IN)         ::  ncid
+
+     CALL check(nf90_def_var(ncid, var%name, NF90_FLOAT,       var%dimids(1:var%ndim), var%varid))
+     CALL check(nf90_put_att(ncid, var%varid, "long_name",     var%long_name))
+     CALL check(nf90_put_att(ncid, var%varid, "units",         var%units))
+     IF ( var%lod .GE. 0 )  THEN
+        CALL check(nf90_put_att(ncid, var%varid, "lod",           var%lod))
+     ENDIF 
+     CALL check(nf90_put_att(ncid, var%varid, "source",        var%source))
+     CALL check(nf90_put_att(ncid, var%varid, "_FillValue",    NF90_FILL_REAL))
+
+ END SUBROUTINE netcdf_define_variable
     
 
@@ -377,18 +382,18 @@
 !> for writing output variables in update_output().
 !------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_get_dimensions(var, ncid)
-
-        TYPE(nc_var), INTENT(INOUT) ::  var
-        INTEGER, INTENT(IN)         ::  ncid
-        INTEGER                     ::  i
-        CHARACTER(SNAME)            ::  null
-
-        DO i = 1, var % ndim
-           CALL check(nf90_inquire_dimension(ncid, var % dimids(i), &
-                                             name = null, &
-                                             len  = var % dimlen(i)  ) )
-        ENDDO
-
-    END SUBROUTINE netcdf_get_dimensions
+ SUBROUTINE netcdf_get_dimensions(var, ncid)
+
+     TYPE(nc_var), INTENT(INOUT) ::  var
+     INTEGER, INTENT(IN)         ::  ncid
+     INTEGER                     ::  i
+     CHARACTER(SNAME)            ::  null
+
+     DO  i = 1, var%ndim
+        CALL check(nf90_inquire_dimension(ncid, var%dimids(i), &
+                                          name = null, &
+                                          len  = var%dimlen(i)  ) )
+     ENDDO
+
+ END SUBROUTINE netcdf_get_dimensions
 
 
@@ -399,65 +404,65 @@
 !> resulting settings in the 'cfg' data structure.
 !------------------------------------------------------------------------------!
-    SUBROUTINE parse_command_line_arguments( cfg )
-
-       TYPE(inifor_config), INTENT(INOUT) ::  cfg
-
-       CHARACTER(LEN=PATH)                ::  option, arg
-       INTEGER                            ::  arg_count, i
-
-       cfg % p0_is_set = .FALSE.
-       cfg % ug_defined_by_user = .FALSE.
-       cfg % vg_defined_by_user = .FALSE.
-       cfg % flow_prefix_is_set = .FALSE.
-       cfg % input_prefix_is_set = .FALSE.
-       cfg % radiation_prefix_is_set = .FALSE.
-       cfg % soil_prefix_is_set = .FALSE.
-       cfg % soilmoisture_prefix_is_set = .FALSE.
-
-       arg_count = COMMAND_ARGUMENT_COUNT()
-       IF (arg_count .GT. 0)  THEN
-
-          message = "The -clon and -clat command line options are depricated. " // &
-             "Please remove them form your inifor command and specify the " // &
-             "location of the PALM-4U origin either" // NEW_LINE(' ') // &
-             "   - by setting the namelist parameters 'longitude' and 'latitude', or" // NEW_LINE(' ') // &
-             "   - by providing a static driver netCDF file via the -static command-line option."
-
-          i = 1
-          DO WHILE (i .LE. arg_count)
-
-             CALL GET_COMMAND_ARGUMENT( i, option )
-
-             SELECT CASE( TRIM(option) )
+ SUBROUTINE parse_command_line_arguments( cfg )
+
+    TYPE(inifor_config), INTENT(INOUT) ::  cfg
+
+    CHARACTER(LEN=PATH)                ::  option, arg
+    INTEGER                            ::  arg_count, i
+
+    cfg%p0_is_set = .FALSE.
+    cfg%ug_defined_by_user = .FALSE.
+    cfg%vg_defined_by_user = .FALSE.
+    cfg%flow_prefix_is_set = .FALSE.
+    cfg%input_prefix_is_set = .FALSE.
+    cfg%radiation_prefix_is_set = .FALSE.
+    cfg%soil_prefix_is_set = .FALSE.
+    cfg%soilmoisture_prefix_is_set = .FALSE.
+
+    arg_count = COMMAND_ARGUMENT_COUNT()
+    IF (arg_count .GT. 0)  THEN
+
+       message = "The -clon and -clat command line options are depricated. " // &
+          "Please remove them form your inifor command and specify the " // &
+          "location of the PALM-4U origin either" // NEW_LINE(' ') // &
+          "   - by setting the namelist parameters 'longitude' and 'latitude', or" // NEW_LINE(' ') // &
+          "   - by providing a static driver netCDF file via the -static command-line option."
+
+       i = 1
+       DO  WHILE (i .LE. arg_count)
+
+          CALL GET_COMMAND_ARGUMENT( i, option )
+
+          SELECT CASE( TRIM(option) )
 
              CASE( '--averaging-mode' )
                 CALL get_option_argument( i, arg )
-                cfg % averaging_mode = TRIM(arg)
+                cfg%averaging_mode = TRIM(arg)
 
              CASE( '-date', '-d', '--date' )
                 CALL get_option_argument( i, arg )
-                cfg % start_date = TRIM(arg)
+                cfg%start_date = TRIM(arg)
 
              CASE( '--debug' )
-                cfg % debug = .TRUE.
+                cfg%debug = .TRUE.
 
              CASE( '-z0', '-z', '--elevation' )
                 CALL get_option_argument( i, arg )
-                READ(arg, *) cfg % z0
+                READ(arg, *) cfg%z0
 
              CASE( '-p0', '-r', '--surface-pressure' )
-                cfg % p0_is_set = .TRUE.
-                CALL get_option_argument( i, arg )
-                READ(arg, *) cfg % p0
+                cfg%p0_is_set = .TRUE.
+                CALL get_option_argument( i, arg )
+                READ(arg, *) cfg%p0
 
              CASE( '-ug', '-u', '--geostrophic-u' )
-                cfg % ug_defined_by_user = .TRUE.
-                CALL get_option_argument( i, arg )
-                READ(arg, *) cfg % ug
+                cfg%ug_defined_by_user = .TRUE.
+                CALL get_option_argument( i, arg )
+                READ(arg, *) cfg%ug
 
              CASE( '-vg', '-v', '--geostrophic-v' )
-                cfg % vg_defined_by_user = .TRUE.
-                CALL get_option_argument( i, arg )
-                READ(arg, *) cfg % vg
+                cfg%vg_defined_by_user = .TRUE.
+                CALL get_option_argument( i, arg )
+                READ(arg, *) cfg%vg
 
              CASE( '-clon', '-clat' )
@@ -466,69 +471,69 @@
              CASE( '-path', '-p', '--path' )
                 CALL get_option_argument( i, arg )
-                 cfg % input_path = TRIM(arg)
+                 cfg%input_path = TRIM(arg)
 
              CASE( '-hhl', '-l', '--hhl-file' )
                 CALL get_option_argument( i, arg )
-                cfg % hhl_file = TRIM(arg)
+                cfg%hhl_file = TRIM(arg)
 
              CASE( '--input-prefix')
                 CALL get_option_argument( i, arg )
-                cfg % input_prefix = TRIM(arg)
-                cfg % input_prefix_is_set = .TRUE.
+                cfg%input_prefix = TRIM(arg)
+                cfg%input_prefix_is_set = .TRUE.
    
              CASE( '-a', '--averaging-angle' )
                 CALL get_option_argument( i, arg )
-                READ(arg, *) cfg % averaging_angle
+                READ(arg, *) cfg%averaging_angle
 
              CASE( '-static', '-t', '--static-driver' )
                 CALL get_option_argument( i, arg )
-                cfg % static_driver_file = TRIM(arg)
+                cfg%static_driver_file = TRIM(arg)
 
              CASE( '-soil', '-s', '--soil-file')
                 CALL get_option_argument( i, arg )
-                cfg % soiltyp_file = TRIM(arg)
+                cfg%soiltyp_file = TRIM(arg)
 
              CASE( '--flow-prefix')
                 CALL get_option_argument( i, arg )
-                cfg % flow_prefix = TRIM(arg)
-                cfg % flow_prefix_is_set = .TRUE.
+                cfg%flow_prefix = TRIM(arg)
+                cfg%flow_prefix_is_set = .TRUE.
    
              CASE( '--radiation-prefix')
                 CALL get_option_argument( i, arg )
-                cfg % radiation_prefix = TRIM(arg)
-                cfg % radiation_prefix_is_set = .TRUE.
+                cfg%radiation_prefix = TRIM(arg)
+                cfg%radiation_prefix_is_set = .TRUE.
    
              CASE( '--soil-prefix')
                 CALL get_option_argument( i, arg )
-                cfg % soil_prefix = TRIM(arg)
-                cfg % soil_prefix_is_set = .TRUE.
+                cfg%soil_prefix = TRIM(arg)
+                cfg%soil_prefix_is_set = .TRUE.
    
              CASE( '--soilmoisture-prefix')
                 CALL get_option_argument( i, arg )
-                cfg % soilmoisture_prefix = TRIM(arg)
-                cfg % soilmoisture_prefix_is_set = .TRUE.
+                cfg%soilmoisture_prefix = TRIM(arg)
+                cfg%soilmoisture_prefix_is_set = .TRUE.
 
              CASE( '-o', '--output' )
                 CALL get_option_argument( i, arg )
-                cfg % output_file = TRIM(arg)
+                cfg%output_file = TRIM(arg)
 
              CASE( '-n', '--namelist' )
                 CALL get_option_argument( i, arg )
-                cfg % namelist_file = TRIM(arg)
+                cfg%namelist_file = TRIM(arg)
 
              CASE( '-mode', '-i', '--init-mode' )
                 CALL get_option_argument( i, arg )
-                cfg % ic_mode = TRIM(arg)
+                cfg%ic_mode = TRIM(arg)
 
              CASE( '-f', '--forcing-mode' )
                 CALL get_option_argument( i, arg )
-                cfg % bc_mode = TRIM(arg)
+                cfg%bc_mode = TRIM(arg)
 
              CASE( '--version' )
-                CALL print_version()
+                CALL print_version
                 STOP
 
              CASE( '--help' )
-                CALL print_version()
+                CALL print_version
                 PRINT *, ""
                 PRINT *, "For a list of command-line options have a look at the README file."
@@ -539,47 +544,47 @@
                 CALL inifor_abort('parse_command_line_arguments', message)
 
-             END SELECT
-
-             i = i + 1
-
-          ENDDO
-
-       ELSE
-            
-          message = "No arguments present, using default input and output files"
-          CALL report('parse_command_line_arguments', message)
-
-       ENDIF
-
-   END SUBROUTINE parse_command_line_arguments
+          END SELECT
+
+          i = i + 1
+
+       ENDDO
+
+    ELSE
+         
+       message = "No arguments present, using default input and output files"
+       CALL report('parse_command_line_arguments', message)
+
+    ENDIF
+
+ END SUBROUTINE parse_command_line_arguments
 
    
 
-   SUBROUTINE get_datetime_file_list( start_date_string, start_hour, end_hour, &
-                                      step_hour, input_path, prefix, suffix,   &
-                                      file_list )
-
-      CHARACTER (LEN=DATE), INTENT(IN) ::  start_date_string
-      CHARACTER (LEN=*),    INTENT(IN) ::  prefix, suffix, input_path
-      INTEGER,              INTENT(IN) ::  start_hour, end_hour, step_hour
-      CHARACTER(LEN=*), ALLOCATABLE, INTENT(INOUT) ::  file_list(:)
-
-      INTEGER             ::  number_of_intervals, hour, i
-      CHARACTER(LEN=DATE) ::  date_string
-
-      number_of_intervals = CEILING( REAL(end_hour - start_hour) / step_hour )
-      ALLOCATE( file_list(number_of_intervals + 1) )
-
-      DO i = 0, number_of_intervals
-
-         hour = start_hour + i * step_hour
-         date_string = add_hours_to(start_date_string, hour)
-
-         file_list(i+1) = TRIM(input_path) // TRIM(prefix) //                  &
-                          TRIM(date_string) // TRIM(suffix) // '.nc'
-
-      ENDDO
-
-   END SUBROUTINE get_datetime_file_list
+ SUBROUTINE get_datetime_file_list( start_date_string, start_hour, end_hour, &
+                                    step_hour, input_path, prefix, suffix,   &
+                                    file_list )
+
+    CHARACTER (LEN=DATE), INTENT(IN) ::  start_date_string
+    CHARACTER (LEN=*),    INTENT(IN) ::  prefix, suffix, input_path
+    INTEGER,              INTENT(IN) ::  start_hour, end_hour, step_hour
+    CHARACTER(LEN=*), ALLOCATABLE, INTENT(INOUT) ::  file_list(:)
+
+    INTEGER             ::  number_of_intervals, hour, i
+    CHARACTER(LEN=DATE) ::  date_string
+
+    number_of_intervals = CEILING( REAL(end_hour - start_hour) / step_hour )
+    ALLOCATE( file_list(number_of_intervals + 1) )
+
+    DO  i = 0, number_of_intervals
+
+       hour = start_hour + i * step_hour
+       date_string = add_hours_to(start_date_string, hour)
+
+       file_list(i+1) = TRIM(input_path) // TRIM(prefix) //                  &
+                        TRIM(date_string) // TRIM(suffix) // '.nc'
+
+    ENDDO
+
+ END SUBROUTINE get_datetime_file_list
 
 !------------------------------------------------------------------------------!
@@ -589,38 +594,38 @@
 !> prefixes and suffixes.
 !------------------------------------------------------------------------------!
-   SUBROUTINE get_input_file_list( start_date_string, start_hour, end_hour,    &
-                                   step_hour, input_path, prefix, suffix,      &
-                                   file_list, nocheck )
-
-      CHARACTER (LEN=DATE), INTENT(IN) ::  start_date_string
-      CHARACTER (LEN=*),    INTENT(IN) ::  prefix, suffix, input_path
-      INTEGER,              INTENT(IN) ::  start_hour, end_hour, step_hour
-      CHARACTER(LEN=*), ALLOCATABLE, INTENT(INOUT) ::  file_list(:)
-      LOGICAL, OPTIONAL, INTENT(IN)    ::  nocheck
-
-      INTEGER ::  i
-      LOGICAL ::  check_files
-
-      CALL get_datetime_file_list( start_date_string, start_hour, end_hour,    &
-                                   step_hour, input_path, prefix, suffix,      &
-                                   file_list )
-
-      check_files = .TRUE.
-      IF ( PRESENT ( nocheck ) )  THEN
-         IF ( nocheck )  check_files = .FALSE.
-      ENDIF
-
-      IF ( check_files )  THEN
-
-         tip = "Please check if you specified the correct file prefix " //     &
-               "using the options --input-prefix, --flow-prefix, etc."
-
-         DO i = 1, SIZE(file_list)
-             CALL verify_file(file_list(i), 'input', tip)
-         ENDDO
-
-      ENDIF
-
-   END SUBROUTINE get_input_file_list
+ SUBROUTINE get_input_file_list( start_date_string, start_hour, end_hour,    &
+                                 step_hour, input_path, prefix, suffix,      &
+                                 file_list, nocheck )
+
+    CHARACTER (LEN=DATE), INTENT(IN) ::  start_date_string
+    CHARACTER (LEN=*),    INTENT(IN) ::  prefix, suffix, input_path
+    INTEGER,              INTENT(IN) ::  start_hour, end_hour, step_hour
+    CHARACTER(LEN=*), ALLOCATABLE, INTENT(INOUT) ::  file_list(:)
+    LOGICAL, OPTIONAL, INTENT(IN)    ::  nocheck
+
+    INTEGER ::  i
+    LOGICAL ::  check_files
+
+    CALL get_datetime_file_list( start_date_string, start_hour, end_hour,    &
+                                 step_hour, input_path, prefix, suffix,      &
+                                 file_list )
+
+    check_files = .TRUE.
+    IF ( PRESENT ( nocheck ) )  THEN
+       IF ( nocheck )  check_files = .FALSE.
+    ENDIF
+
+    IF ( check_files )  THEN
+
+       tip = "Please check if you specified the correct file prefix " //     &
+             "using the options --input-prefix, --flow-prefix, etc."
+
+       DO  i = 1, SIZE(file_list)
+           CALL verify_file(file_list(i), 'input', tip)
+       ENDDO
+
+    ENDIF
+
+ END SUBROUTINE get_input_file_list
 
 
